
;CodeVisionAVR C Compiler V2.04.4 Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 11,059200 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : Off
;Automatic register allocation : Off

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _adc_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;
;
;  ==============================
;
;  -   AVR ATmega ATtiny
; PIC   - http://proavr.narod.ru
;
;  -   -   AVR  PIC - avr123.nm.ru    pid.by.ru
;
;    AVR.
;
;"   " -    !!!         -
;   .   http://proavr.narod.ru/05.htm
;
;==============================
;
;ATmega8  ATmega48   48   DIP28        -
;  1  10  80 ,       
;.           
; USB AVR910 USBASP PicKit2  - http://mkpochtoi.narod.ru
;
;ATmega16   80   DIP40
;
;  USB AVR910 USBASP PicKit2  .
;
;
;          ""
;       -    
;         .   
;   -  , .
;        .
;
;http://mkpochtoi.narod.ru
;
;   .
;
;==============================
;
;
;      
;CVAVR CodeVisinAVR -
;
;         .   http://proavr.narod.ru
;
;    http://proavr.narod.ru/06.htm
;
;CVAVR  -      .
;
;
; -   translate.ru
;
;; ************************************************************
;
;      VMLAB   4.3 Mb 
;(   http://proavr.narod.ru )  :
;
;http://proavr.narod.ru/z2.htm
;http://proavr.narod.ru/z3.htm
;http://proavr.narod.ru/z9.htm
;
;        VMLAB
;
;; ************************************************************
;
;  "-"   
;  -   :  http://proavr.narod.ru/z4.htm
;
;
;///////////////////////////////////////////////////////////////
;
;       - PROTEUS  !!!
;
;          
;
;  http://proteus123.narod.ru
;
;==============================
;
;     -    - www.AVR123.nm.ru
;
; 187   +  CD c     - -  .
;http://torrents.ru/forum/viewtopic.php?t=1652142
;
;==============================
;
;AVR Studio 4.16  build 628. : 127 MB     :
;     http://www.efo.ru/ftp/pub/atmel/_AVR_MCUs_8bit/AvrStudio/AVR%20Studio%204.16%20628/AvrStudio416Setup.exe
;
;===============================
;
;
;AVR Studio 4.17 (build 666) Software (updated 2009-07)
;
;http://www.efo.ru/ftp/pub/atmel/_AVR_MCUs_8bit/AvrStudio/AVR%20Studio%204.17%20666/AvrStudio417Setup.exe
;
;http://www.atmel.com/dyn/general/tech_doc.asp?doc_id=12246
;
;  AVR - Tiny4, Tiny5, Tiny9, Tiny87, Tiny861A, Tiny2313A, Tiny4313, Mega16HVB, Mega16M1, Mega64M1, Mega64C1, Mega8U2, Mega16U2, Mega32U2, XMmega192D3, AT90SCR100, Mega128RFA1  .
;
;
;AVR Studio 4.17 includes new device support and numerous overall enhancements;
;Full AVR ONE! 8-bit support - both programming and debugging, AVR Battery Studio version 1.02, JTAGICE mkII command line SW with support for ELF production file format, and STK500 command line SW with support for ELF production file format.
;
;===============================
;
;AVR Studio 4.18 (build 684) (116 MB, updated 11/09)
;
;http://www.atmel.com/dyn/products/tools_card.asp?tool_id=2725
;
;
;
;AVR Studio 4.18 Part Pack 1 - 
;
;http://www.atmel.no/beta_ware/avrstudio418/pp1/AVR_Studio_4.18_PP1.exe
;
;AVR Studio 4.18 PP1 adds support for 5 new devices: ATmega328, ATmega164A, ATmega324A, ATmega644A, ATmega1284
;
;
;===============================
;
;  ATMEL - http://www.atmel.com/dyn/products/tools.asp?family_id=607
;
;  ATMEL   - http://www.atmel.no/beta_ware/
;
;
;
;
;Project :
;Version :
;Date    : 06.01.2010
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 11,059200 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdlib.h>
;#include <math.h>
;#include <string.h>
;
;#define dig_0 0b00111111
;#define dig_1 0b00000110
;#define dig_2 0b01011011
;#define dig_3 0b01001111
;#define dig_4 0b01100110
;#define dig_5 0b01101101
;#define dig_6 0b01111101
;#define dig_7 0b00000111
;#define dig_8 0b01111111
;#define dig_9 0b01101111
;
;#define DATAIN PORTB.0
;#define CLK PORTB.1
;#define LOAD PORTB.3
;
;// Declare your global variables here
;unsigned int adc_data;
;unsigned char ADCstr[4];
;// ADC interrupt service routine
;void sendLCD(unsigned int pos, unsigned char digitChar)
; 0000 00AB {

	.CSEG
_sendLCD:
; 0000 00AC unsigned int digit;
; 0000 00AD  switch (digitChar) {
	ST   -Y,R17
	ST   -Y,R16
;	pos -> Y+3
;	digitChar -> Y+2
;	digit -> R16,R17
	LDD  R30,Y+2
	LDI  R31,0
; 0000 00AE     case '0': digit = dig_0; break;
	CPI  R30,LOW(0x30)
	LDI  R26,HIGH(0x30)
	CPC  R31,R26
	BRNE _0x6
	__GETWRN 16,17,63
	RJMP _0x5
; 0000 00AF     case '1': digit = dig_1; break;
_0x6:
	CPI  R30,LOW(0x31)
	LDI  R26,HIGH(0x31)
	CPC  R31,R26
	BRNE _0x7
	__GETWRN 16,17,6
	RJMP _0x5
; 0000 00B0     case '2': digit = dig_2; break;
_0x7:
	CPI  R30,LOW(0x32)
	LDI  R26,HIGH(0x32)
	CPC  R31,R26
	BRNE _0x8
	__GETWRN 16,17,91
	RJMP _0x5
; 0000 00B1     case '3': digit = dig_3; break;
_0x8:
	CPI  R30,LOW(0x33)
	LDI  R26,HIGH(0x33)
	CPC  R31,R26
	BRNE _0x9
	__GETWRN 16,17,79
	RJMP _0x5
; 0000 00B2     case '4': digit = dig_4; break;
_0x9:
	CPI  R30,LOW(0x34)
	LDI  R26,HIGH(0x34)
	CPC  R31,R26
	BRNE _0xA
	__GETWRN 16,17,102
	RJMP _0x5
; 0000 00B3     case '5': digit = dig_5; break;
_0xA:
	CPI  R30,LOW(0x35)
	LDI  R26,HIGH(0x35)
	CPC  R31,R26
	BRNE _0xB
	__GETWRN 16,17,109
	RJMP _0x5
; 0000 00B4     case '6': digit = dig_6; break;
_0xB:
	CPI  R30,LOW(0x36)
	LDI  R26,HIGH(0x36)
	CPC  R31,R26
	BRNE _0xC
	__GETWRN 16,17,125
	RJMP _0x5
; 0000 00B5     case '7': digit = dig_7; break;
_0xC:
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	BRNE _0xD
	__GETWRN 16,17,7
	RJMP _0x5
; 0000 00B6     case '8': digit = dig_8; break;
_0xD:
	CPI  R30,LOW(0x38)
	LDI  R26,HIGH(0x38)
	CPC  R31,R26
	BRNE _0xE
	__GETWRN 16,17,127
	RJMP _0x5
; 0000 00B7     case '9': digit = dig_9; break;
_0xE:
	CPI  R30,LOW(0x39)
	LDI  R26,HIGH(0x39)
	CPC  R31,R26
	BRNE _0x5
	__GETWRN 16,17,111
; 0000 00B8     };
_0x5:
; 0000 00B9     switch (pos) {
	LDD  R30,Y+3
	LDD  R31,Y+3+1
; 0000 00BA     case 2: PORTD = digit; break;
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x13
	OUT  0x12,R16
	RJMP _0x12
; 0000 00BB     case 1: PORTC = digit; break;
_0x13:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x14
	OUT  0x15,R16
	RJMP _0x12
; 0000 00BC     case 0: PORTB = digit; break;
_0x14:
	SBIW R30,0
	BRNE _0x12
	OUT  0x18,R16
; 0000 00BD     };
_0x12:
; 0000 00BE }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
;
;void resetLCDdriver()
; 0000 00C1 {
_resetLCDdriver:
; 0000 00C2     unsigned int i;
; 0000 00C3     CLK = 1;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	SBI  0x18,1
; 0000 00C4     LOAD = 0;
	CBI  0x18,3
; 0000 00C5   for (i = 0; i < 32; i++)
	__GETWRN 16,17,0
_0x1B:
	__CPWRN 16,17,32
	BRSH _0x1C
; 0000 00C6   {
; 0000 00C7     DATAIN = 1;
	SBI  0x18,0
; 0000 00C8     CLK = 0;
	CBI  0x18,1
; 0000 00C9     CLK = 1;
	SBI  0x18,1
; 0000 00CA   }
	__ADDWRN 16,17,1
	RJMP _0x1B
_0x1C:
; 0000 00CB   LOAD = 1;
	SBI  0x18,3
; 0000 00CC   //LOAD = 0;
; 0000 00CD }
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;interrupt [ADC_INT] void adc_isr(void)
; 0000 00D0 {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D1 unsigned int adc_value;
; 0000 00D2 unsigned int i;
; 0000 00D3 unsigned int l = strlen(ADCstr);
; 0000 00D4 // Read the AD conversion result
; 0000 00D5 adc_data=ADCW;
	CALL __SAVELOCR6
;	adc_value -> R16,R17
;	i -> R18,R19
;	l -> R20,R21
	LDI  R30,LOW(_ADCstr)
	LDI  R31,HIGH(_ADCstr)
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOVW R20,R30
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _adc_data,R30
	STS  _adc_data+1,R31
; 0000 00D6 // Yerevanskiy sapfir
; 0000 00D7 adc_value = adc_data;
	__GETWRMN 16,17,0,_adc_data
; 0000 00D8 
; 0000 00D9 // Moskovskij sapfir
; 0000 00DA // adc_value = adc_data>>1
; 0000 00DB 
; 0000 00DC itoa(adc_value, ADCstr);
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_ADCstr)
	LDI  R31,HIGH(_ADCstr)
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 00DD 
; 0000 00DE     for (i = 0; i < l; i++) {
	__GETWRN 18,19,0
_0x26:
	__CPWRR 18,19,20,21
	BRSH _0x27
; 0000 00DF         switch (i) {
	MOVW R30,R18
; 0000 00E0         case 2: sendLCD(2, ADCstr[i]); break;
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2B
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x32
; 0000 00E1         case 1: sendLCD(1, ADCstr[i]); break;
_0x2B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2C
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x32
; 0000 00E2         case 0: sendLCD(0, ADCstr[i]); break;
_0x2C:
	SBIW R30,0
	BRNE _0x2A
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x32:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_ADCstr)
	LDI  R27,HIGH(_ADCstr)
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	ST   -Y,R30
	RCALL _sendLCD
; 0000 00E3         };
_0x2A:
; 0000 00E4 
; 0000 00E5     }
	__ADDWRN 18,19,1
	RJMP _0x26
_0x27:
; 0000 00E6 
; 0000 00E7 
; 0000 00E8 ADCSRA |= (1<<6); //  
	SBI  0x6,6
; 0000 00E9 
; 0000 00EA }
	CALL __LOADLOCR6
	ADIW R28,6
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void init_avr(void)
; 0000 00ED {
_init_avr:
; 0000 00EE // Declare your local variables here
; 0000 00EF 
; 0000 00F0 // Input/Output Ports initialization
; 0000 00F1 // Port A initialization
; 0000 00F2 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00F3 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00F4 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 00F5 DDRA=0x00;
	OUT  0x1A,R30
; 0000 00F6 
; 0000 00F7 // Port B initialization
; 0000 00F8 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00F9 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00FA PORTB=0x00;
	OUT  0x18,R30
; 0000 00FB DDRB=0x00;
	OUT  0x17,R30
; 0000 00FC 
; 0000 00FD // Port C initialization
; 0000 00FE // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00FF // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0100 PORTC=0x00;
	OUT  0x15,R30
; 0000 0101 DDRC=0x00;
	OUT  0x14,R30
; 0000 0102 
; 0000 0103 // Port D initialization
; 0000 0104 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0105 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0106 PORTD=0x00;
	OUT  0x12,R30
; 0000 0107 DDRD=0x00;
	OUT  0x11,R30
; 0000 0108 
; 0000 0109 // Timer/Counter 0 initialization
; 0000 010A // Clock source: System Clock
; 0000 010B // Clock value: Timer 0 Stopped
; 0000 010C // Mode: Normal top=FFh
; 0000 010D // OC0 output: Disconnected
; 0000 010E TCCR0=0x00;
	OUT  0x33,R30
; 0000 010F TCNT0=0x00;
	OUT  0x32,R30
; 0000 0110 OCR0=0x00;
	OUT  0x3C,R30
; 0000 0111 
; 0000 0112 // Timer/Counter 1 initialization
; 0000 0113 // Clock source: System Clock
; 0000 0114 // Clock value: Timer1 Stopped
; 0000 0115 // Mode: Normal top=FFFFh
; 0000 0116 // OC1A output: Discon.
; 0000 0117 // OC1B output: Discon.
; 0000 0118 // Noise Canceler: Off
; 0000 0119 // Input Capture on Falling Edge
; 0000 011A // Timer1 Overflow Interrupt: Off
; 0000 011B // Input Capture Interrupt: Off
; 0000 011C // Compare A Match Interrupt: Off
; 0000 011D // Compare B Match Interrupt: Off
; 0000 011E TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 011F TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0120 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0121 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0122 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0123 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0124 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0125 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0126 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0127 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0128 
; 0000 0129 // Timer/Counter 2 initialization
; 0000 012A // Clock source: System Clock
; 0000 012B // Clock value: Timer2 Stopped
; 0000 012C // Mode: Normal top=FFh
; 0000 012D // OC2 output: Disconnected
; 0000 012E ASSR=0x00;
	OUT  0x22,R30
; 0000 012F TCCR2=0x00;
	OUT  0x25,R30
; 0000 0130 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0131 OCR2=0x00;
	OUT  0x23,R30
; 0000 0132 
; 0000 0133 // External Interrupt(s) initialization
; 0000 0134 // INT0: Off
; 0000 0135 // INT1: Off
; 0000 0136 // INT2: Off
; 0000 0137 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0138 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0139 
; 0000 013A // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 013B TIMSK=0x00;
	OUT  0x39,R30
; 0000 013C 
; 0000 013D // Analog Comparator initialization
; 0000 013E // Analog Comparator: Off
; 0000 013F // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0140 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0141 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0142 
; 0000 0143 // ADC initialization
; 0000 0144 // ADC Clock frequency: 86,400 kHz
; 0000 0145 // ADC Voltage Reference: Int., cap. on AREF
; 0000 0146 ADMUX=0b11010000;
	LDI  R30,LOW(208)
	OUT  0x7,R30
; 0000 0147 ADCSRA=0x8F;
	LDI  R30,LOW(143)
	OUT  0x6,R30
; 0000 0148 
; 0000 0149 // 2 Wire Bus initialization
; 0000 014A // Generate Acknowledge Pulse: Off
; 0000 014B // 2 Wire Bus Slave Address: 0h
; 0000 014C // General Call Recognition: Off
; 0000 014D // Bit Rate: 394,971 kHz
; 0000 014E TWSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x1,R30
; 0000 014F TWBR=0x06;
	LDI  R30,LOW(6)
	OUT  0x0,R30
; 0000 0150 TWAR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 0151 TWCR=0x04;
	LDI  R30,LOW(4)
	OUT  0x36,R30
; 0000 0152 
; 0000 0153 // Global enable interrupts
; 0000 0154 #asm("sei")
	sei
; 0000 0155 }
	RET
;
;void main(void)
; 0000 0158 {
_main:
; 0000 0159 
; 0000 015A init_avr();
	RCALL _init_avr
; 0000 015B 
; 0000 015C //ADCSRA |= (1<<6); //  
; 0000 015D 
; 0000 015E resetLCDdriver();
	RCALL _resetLCDdriver
; 0000 015F 
; 0000 0160 while (1)
_0x2E:
; 0000 0161       {
; 0000 0162       // Place your code here
; 0000 0163 
; 0000 0164       };
	RJMP _0x2E
; 0000 0165 }
_0x31:
	RJMP _0x31

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret

	.CSEG

	.DSEG
_adc_data:
	.BYTE 0x2
_ADCstr:
	.BYTE 0x4
__seed_G100:
	.BYTE 0x4

	.CSEG

	.CSEG
__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
